"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateNode = void 0;
require('dotenv').config();
const debug_1 = __importDefault(require("debug"));
const apollo_boost_1 = require("apollo-boost");
const check_1 = require("../check");
const client_1 = require("../client");
const onedirectional_1 = require("../imports/onedirectional");
const debug = (0, debug_1.default)('materialized-path:test');
const DELAY = +process.env.DELAY || 0;
const delay = time => new Promise(res => setTimeout(res, time));
const itDelay = () => {
    if (DELAY) {
        (it)('delay', () => __awaiter(void 0, void 0, void 0, function* () {
            yield delay(DELAY);
        }));
    }
};
const updateNode = (linkId, fromId, toId) => __awaiter(void 0, void 0, void 0, function* () {
    var _a, _b, _c, _d;
    const result = yield client_1.client.mutate({ mutation: (0, apollo_boost_1.gql) `mutation InsertNode($linkId: ${onedirectional_1.ID_TYPE}, $fromId: ${onedirectional_1.ID_TYPE} $toId: ${onedirectional_1.ID_TYPE}) {
    update_links: update_${onedirectional_1.GRAPH_TABLE}(where: { id: { _eq: $linkId } }, _set: { from_id: $fromId, to_id: $toId }) { returning { id } }
  }`, variables: { linkId, fromId, toId } });
    if (result === null || result === void 0 ? void 0 : result.errors) {
        console.error('updateNode', linkId);
        throw result === null || result === void 0 ? void 0 : result.errors;
    }
    const id = (_d = (_c = (_b = (_a = result === null || result === void 0 ? void 0 : result.data) === null || _a === void 0 ? void 0 : _a.update_links) === null || _b === void 0 ? void 0 : _b.returning) === null || _c === void 0 ? void 0 : _c[0]) === null || _d === void 0 ? void 0 : _d.id;
    debug(`update node #${id} to #${fromId}-#${toId}`);
    return id;
});
exports.updateNode = updateNode;
beforeAll(onedirectional_1.beforeAllHandler);
(it)('prepare', onedirectional_1.prepare);
it('+2 update b', (0, onedirectional_1.testPlus2)(true, ({ a, b, c }, type_id) => __awaiter(void 0, void 0, void 0, function* () {
    yield (0, exports.updateNode)(c, b, a);
    yield (0, check_1.checkManual)([
        [a, 0, 0, type_id, [[b, b], [b, c], [b, a]]],
        [b, 0, 0, type_id, [[b, b]]],
        [c, b, a, type_id, [[b, b], [b, c]]],
    ], type_id, onedirectional_1.GRAPH_TABLE, onedirectional_1.MP_TABLE);
})));
it('+5 update y', (0, onedirectional_1.testPlus5)(true, ({ a, b, c, d, e, x, y }, type_id) => __awaiter(void 0, void 0, void 0, function* () {
    yield (0, exports.updateNode)(y, b, x);
    yield (0, check_1.checkManual)([
        [a, 0, 0, type_id, [[a, a]]],
        [b, 0, 0, type_id, [[a, a], [a, c], [a, b]]],
        [c, a, b, type_id, [[a, a], [a, c]]],
        [d, 0, 0, type_id, [[a, a], [a, c], [a, b], [a, e], [a, d]]],
        [e, b, d, type_id, [[a, a], [a, c], [a, b], [a, e]]],
        [x, 0, 0, type_id, [[a, a], [a, c], [a, b], [a, y], [a, x]]],
        [y, b, x, type_id, [[a, a], [a, c], [a, b], [a, y]]],
    ], type_id, onedirectional_1.GRAPH_TABLE, onedirectional_1.MP_TABLE);
})));
//# sourceMappingURL=update-onedirectional.js.map